import numpy as np

from gui.layer import GridLayer
from .OpenGLLayer import OpenGLLayer


class OpenGLGridLayer(OpenGLLayer, GridLayer):

    def setTiles(self, grid: np.ndarray):
        assert grid.ndim == 3
        gridWidth = grid.shape[0]
        gridHeight = grid.shape[1]
        assert grid.shape[2] == 2

        self.createFaces(gridWidth * gridHeight)
        faceIndex = 0
        for y in range(gridHeight):
            for x in range(gridWidth):
                self.setFaceTileLocation(faceIndex, x, y)
                self.setFaceTileTexture(faceIndex, grid[x, y, 0], grid[x, y, 1])
                faceIndex += 1

        self.sendData(dynamic=False)

