from abc import ABC, abstractmethod
from typing import List

from . import KeyEvent


class Keyboard(ABC):

    @abstractmethod
    def isKeyPressed(self, key: int) -> bool:
        raise NotImplementedError()

    @property
    @abstractmethod
    def keyEvents(self) -> List[KeyEvent]:
        raise NotImplementedError()

    @abstractmethod
    def clearKeyEvents(self):
        raise NotImplementedError()

    K_NONE = 0

    K_LEFT = 1
    K_RIGHT = 2
    K_UP = 3
    K_DOWN = 4

    K_ESCAPE = 5

    K_MAXCODE = 6



